//
// Copyright (C) 2010  Clement Creusot
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <stdio.h>
#include <fstream>

#include "settings.h"
#include "common.h"

using namespace std;

//Initialisation of the Settings class (allow only one singleton)
Settings * Settings::Instance = 0;


void Settings::ReadConfig(std::string confname){  
  ifstream in;
  string buff, name, tmp;
  int count;
  vector<map<string, string> >* tab;  
  
  if (confname.size()!=0){
    this->configFileName = confname;
  }

  if (this->configFileName.size() <1){
    PRINT_ERROR("No configuration file have been given.");
  }
  in.open(this->configFileName.c_str());
  if(!in) { 
    PRINT_ERROR("Unable to open the file.");
  }

  in >> buff;
  while( !in.eof() ){
    if (buff[0] == '#'){
      // if we read a comment, read all the line
      getline(in, buff);
    }
    else{
      // read the lists of argument
      if(buff.compare("neighborhood") ==0){
	tab = &this->neighborhood;
      }
      else if(buff.compare("field") ==0){
	tab = &this->field;
      }
      else{
	PRINT_ERROR("Not recognized sentence: %s", buff.c_str());
      }      
      
      tab->resize(tab->size()+1);
      in >> count;
      for(int i=0; i < count; i++){
	in >> name;
	in >> tmp;
	if (tmp.compare("\"\"") ==0){
	  tab->back()[name] = "";
	}
	else{
	  tab->back()[name] = tmp;
	}
      }
    }
    in >>buff;
  }
  in.close();

}

bool Settings::IsInteractive()
{
  return this->interactiveMode;
}

