//
// Copyright (C) 2010  Clement Creusot
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef VTKCUSTOMH
#define VTKCUSTOMH


#include "vtkPolyDataNormals.h"
#include "vtkConeSource.h"
#include "vtkPoints.h"
#include "vtkPointData.h"
#include "vtkPolyData.h"
#include "vtkGlyph3D.h"
#include "vtkPolyDataMapper.h"
#include "vtkActor.h"
#include "vtkSphereSource.h"
#include "vtkDoubleArray.h"
#include "vtkRenderer.h"
#include "vtkRenderWindow.h"
#include "vtkRenderWindowInteractor.h"
#include "vtkCamera.h"
#include "vtkInteractorStyleTrackballCamera.h"
#include "vtkCellArray.h"
#include "vtkProperty.h"
#include "vtkWindowToImageFilter.h"
#include "vtkPNGWriter.h"
#include "vtkCallbackCommand.h"



#include "common.h"
//#include "settings.h"

#include <string>




// Capture the display and place in a png
inline static void CaptureImage(vtkRenderWindow* renWin, std::string name =""){
  
  if (name.compare("")==0){
    int nb = 0;
    while(1){
      name = "capture";
      name.append(zfill(nb,3));
      name.append(".png");
      ifstream ifile(name.c_str());
      if (! ifile){
	ifile.close();
	break;
      }
      ifile.close();
      nb++;
    }
    cerr << "Screenshot file produced: " << name << std::endl;
  }       
  else{
    name.append(".png");
  }
  vtkWindowToImageFilter * w2i = vtkWindowToImageFilter::New();
  w2i->SetInput(renWin);
  w2i->Update();
  vtkPNGWriter * writer = vtkPNGWriter::New();
  writer->SetInputConnection(w2i->GetOutputPort());
  writer->SetFileName(name.c_str());
  renWin->Render();
  writer->Write();
}


static void handle_user_button_as_capture(vtkObject* object,
					  unsigned long event,
					  void* clientdata,
					  void* vtkNotUsed(calldata))
{  
  vtkRenderWindowInteractor* ir = 
    vtkRenderWindowInteractor::SafeDownCast(object); 
  
  CaptureImage(ir->GetRenderWindow());
  //  ir->ExitCallback();
};










#endif
