//
// Copyright (C) 2010  Clement Creusot
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.


#ifndef LOCALSYMETRYDESCRIPTORH
#define LOCALSYMETRYDESCRIPTORH

#include <list>
#include <vector>
#include "../neighborhood.h"


class LocalSymetryDescriptor 
{
 public :
  
  LocalSymetryDescriptor(const Neighborhood * n,
			 double radiusBinSize,
			 double angleBinNb,
			 const std::vector<Histogram*>* normals,
			 const std::vector<Histogram*>* startingDirections=NULL,
			 const std::vector<double>* values=NULL);
  ~LocalSymetryDescriptor();
    
  const std::vector<double>& GetLSD() const{return LSD;};

 private:
  double radiusBinSize;
  double angleBinNb;
  std::vector<double> LSD;
  const Neighborhood * neighborhood;
  const std::vector<Histogram*>* normals;
  const std::vector<Histogram*>* startingDirections; // one vector non-colinear with the normal 
  const std::vector<double>* values; // one vector non-colinear with the normal 

  void Compute();

};

#endif
