//
// Copyright (C) 2010  Clement Creusot
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.


#ifndef WILLMOREH
#define WILLMOREH

#include <list>
#include <vector>
#include "../mesh.h"


class Willmore 
{
 public :
  
  Willmore(const Mesh * m,const std::vector<int>* subset=NULL);
  ~Willmore();
    
  const std::vector<double>& GetValues() const{return willmore;};

 private:
  const Mesh * mesh;
  std::vector<double> willmore;

  void Compute(const std::vector<int>* subset=NULL);

};

#endif
