//
// Copyright (C) 2010  Clement Creusot
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SUPPORTGENERATORH
#define SUPPORTGENERATORH

#include <list>
#include <vector>
#include <map>
#include "mesh.h"
#include "neighborhood.h"
#include "histogram.h"

// Get the main support structure using the parameters defined in 'settings'

class SupportGenerator
{
 public :
  
  // FIXME add other constructors   
  // fill the structure using the vtkpolydata
  SupportGenerator(){};
  ~SupportGenerator(){};

  void GetNeighborhoods(Mesh * mesh, 
			std::map<std::string, Neighborhood*>& neighborhoods,
			const std::vector<int>* subset=NULL);

  void GetFields(Mesh * mesh,
		 std::map<std::string, Neighborhood*>& neighborhoods,
		 std::map<std::string, std::vector<double> * >& scalars,
		 std::map<std::string, std::vector<Histogram*>* >& vectors,
		 const std::vector<int> * subset = NULL);


  
 private:


};

// print scalars when debuging
std::ostream& operator<<(std::ostream& stream,std::vector<double>& scalar);
std::ostream& operator<<(std::ostream& stream,std::vector<double*>& vector);


#endif
